/* STMApplication (c) Thorbjörn Jemander */

#include <stdarg.h>
#include <stdio.h>

#include "Alerts.h"
//#include "Debug/dbug.h"

void    DisplayEmpty( const char *argDisplayText, ... )
{
	va_list args;
	char buf[1024];	/* FIXME! */

	va_start( args, argDisplayText );

	vsprintf (buf, argDisplayText, args);
	
	va_end (args);

	BAlert *a = new BAlert("",
							buf,
							"OK",
							NULL,
							NULL,
							B_WIDTH_AS_USUAL,
							B_INFO_ALERT
							);
	a->Go();
}

void    DisplayInfo(    const char *argDisplayText, ...  )
{
	va_list args;
	char buf[1024];	/* FIXME! */

	va_start( args, argDisplayText );

	vsprintf (buf, argDisplayText, args);
	
	va_end (args);

	BAlert *a = new BAlert("",
							buf,
							"OK",
							NULL,
							NULL,
							B_WIDTH_AS_USUAL,
							B_INFO_ALERT
							);
	a->Go();
}



void    DisplayIdea(    const char *argDisplayText, ...  )
{
	va_list args;
	char buf[1024];	/* FIXME! */

	va_start( args, argDisplayText );

	vsprintf (buf, argDisplayText, args);
	
	va_end (args);

	BAlert *a = new BAlert(
							"",
							buf,
							"OK",
							NULL,
							NULL,
							B_WIDTH_AS_USUAL,
							B_IDEA_ALERT
							);
	a->Go();
}

void    DisplayWarning( const char *argDisplayText, ...  )
{
	va_list args;
	char buf[1024];	/* FIXME! */

	va_start( args, argDisplayText );

	vsprintf (buf, argDisplayText, args);
	
	va_end (args);

	BAlert *a = new BAlert(
							"",
							buf,
							"OK",
							NULL,
							NULL,
							B_WIDTH_AS_USUAL,
							B_WARNING_ALERT
							);
	a->Go();
}

void    DisplayStop(    const char *argDisplayText, ...  )
{
	va_list args;
	char buf[1024];	/* FIXME! */

	va_start( args, argDisplayText );

	vsprintf (buf, argDisplayText, args);
	
	va_end (args);

	BAlert *a = new BAlert("",
							buf,
							"OK",
							NULL,
							NULL,
							B_WIDTH_AS_USUAL,
							B_STOP_ALERT
							);
	a->Go();
}

void	DisplayOutOfMemory()
{
	try
	{
		BAlert *a = new BAlert("",
								"I've runned out of memory! I will stop this operation. A good idea is to quit some programs and try again.",
								"OK",
								NULL,
								NULL,
								B_WIDTH_AS_USUAL,
								B_STOP_ALERT
								);
		a->Go();
	}
	catch( bad_alloc & e )
	{
//		DBUG_PRINT("Eeek!",("TOTALLY OUT OF MEMORY! Good bye!"));
		exit(99);	
	}
}

void	DisplayDisaster(    const char *argDisplayText, ... )
{
	try
	{
		va_list args;
		char buf[1024];	/* FIXME! */
	
		va_start( args, argDisplayText );
	
		vsprintf (buf, argDisplayText, args);
		
		va_end (args);

		DisplayStop("There is something severely wrong with the program: '%s' That is due to me uncontrollable circumstances. I have to quit running.", argDisplayText );

		exit(99);
	}
	catch( bad_alloc & e )
	{
//		DBUG_PRINT("Eeek!",("TOTALLY OUT OF MEMORY! Good bye!"));
		exit(99);	
	}

}
