///////////////////////////////////////////
//
// file:  CMP.cpp
//
// Copyright 2004 John R. Ashmun
//                jrashmun@halcyon.com
//
//    This file is part of MIX. 
//
//    MIX is free software; you can redistribute it and/or modify 
//    it under the terms of the GNU General Public License as
//    published by the Free Software Foundation; either version 2
//    of the License, or (at your option) any later version. 
//
//    MIX is distributed in the hope that it will be useful, 
//    but WITHOUT ANY WARRANTY; without even the implied warranty of 
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
//    GNU General Public License for more details. 
//
//    You should have received a copy of the GNU General Public
//    License along with MIX; if not, write to the
//    Free Software Foundation, Inc.
//    59 Temple Place, Suite 330
//    Boston MA 02111-1307  USA
//
///////////////////////////////////////////


#include "MIX.h"


void CMP( )
{
   int f = INST.F( );
   int L = f >> 3;
   int m = INST.M( );
   int m_byte = 0;
   int m_field = 0;
   int opcode = INST.C( );
   int R = f & 7;
   int reg_byte = 0;
   int reg_field = 0;

   while( R >= L )
   {
      switch( opcode )
      {
         case 56:
            switch( R )
            {
               case 5:
                  reg_byte = AREG.Byte_5( );
                  break;

               case 4:
                  reg_byte = AREG.Byte_4( );
                  break;

               case 3:
                  reg_byte = AREG.Byte_3( );
                  break;

               case 2:
                  reg_byte = AREG.Byte_2( );
                  break;

               case 1:
                  reg_byte = AREG.Byte_1( );
                  break;

               case 0:
                  reg_byte = AREG.Byte_0( );
                  break;

               default:
                  break;
            }
            break;

         case 57:
            switch( R )
            {
               case 5:
                  reg_byte = I1REG.Byte_5( );
                  break;

               case 4:
                  reg_byte = I1REG.Byte_4( );
                  break;

               case 3:
                  reg_byte = I1REG.Byte_3( );
                  break;

               case 2:
                  reg_byte = I1REG.Byte_2( );
                  break;

               case 1:
                  reg_byte = I1REG.Byte_1( );
                  break;

               case 0:
                  reg_byte = I1REG.Byte_0( );
                  break;

               default:
                  break;
            }
            break;

         case 58:
            switch( R )
            {
               case 5:
                  reg_byte = I2REG.Byte_5( );
                  break;

               case 4:
                  reg_byte = I2REG.Byte_4( );
                  break;

               case 3:
                  reg_byte = I2REG.Byte_3( );
                  break;

               case 2:
                  reg_byte = I2REG.Byte_2( );
                  break;

               case 1:
                  reg_byte = I2REG.Byte_1( );
                  break;

               case 0:
                  reg_byte = I2REG.Byte_0( );
                  break;

               default:
                  break;
            }
            break;

         case 59:
            switch( R )
            {
               case 5:
                  reg_byte = I3REG.Byte_5( );
                  break;

               case 4:
                  reg_byte = I3REG.Byte_4( );
                  break;

               case 3:
                  reg_byte = I3REG.Byte_3( );
                  break;

               case 2:
                  reg_byte = I3REG.Byte_2( );
                  break;

               case 1:
                  reg_byte = I3REG.Byte_1( );
                  break;

               case 0:
                  reg_byte = I3REG.Byte_0( );
                  break;

               default:
                  break;
            }
            break;

         case 60:
            switch( R )
            {
               case 5:
                  reg_byte = I4REG.Byte_5( );
                  break;

               case 4:
                  reg_byte = I4REG.Byte_4( );
                  break;

               case 3:
                  reg_byte = I4REG.Byte_3( );
                  break;

               case 2:
                  reg_byte = I4REG.Byte_2( );
                  break;

               case 1:
                  reg_byte = I4REG.Byte_1( );
                  break;

               case 0:
                  reg_byte = I4REG.Byte_0( );
                  break;

               default:
                  break;
            }
            break;

         case 61:
            switch( R )
            {
               case 5:
                  reg_byte = I5REG.Byte_5( );
                  break;

               case 4:
                  reg_byte = I5REG.Byte_4( );
                  break;

               case 3:
                  reg_byte = I5REG.Byte_3( );
                  break;

               case 2:
                  reg_byte = I5REG.Byte_2( );
                  break;

               case 1:
                  reg_byte = I5REG.Byte_1( );
                  break;

               case 0:
                  reg_byte = I5REG.Byte_0( );
                  break;

               default:
                  break;
            }
            break;

         case 62:
            switch( R )
            {
               case 5:
                  reg_byte = I6REG.Byte_5( );
                  break;

               case 4:
                  reg_byte = I6REG.Byte_4( );
                  break;

               case 3:
                  reg_byte = I6REG.Byte_3( );
                  break;

               case 2:
                  reg_byte = I6REG.Byte_2( );
                  break;

               case 1:
                  reg_byte = I6REG.Byte_1( );
                  break;

               case 0:
                  reg_byte = I6REG.Byte_0( );
                  break;

               default:
                  break;
            }
            break;

         case 63:
            switch( R )
            {
               case 5:
                  reg_byte = XREG.Byte_5( );
                  break;

               case 4:
                  reg_byte = XREG.Byte_4( );
                  break;

               case 3:
                  reg_byte = XREG.Byte_3( );
                  break;

               case 2:
                  reg_byte = XREG.Byte_2( );
                  break;

               case 1:
                  reg_byte = XREG.Byte_1( );
                  break;

               case 0:
                  reg_byte = XREG.Byte_0( );
                  break;

               default:
                  break;
            }
            break;

         default:
            break;
      }

      switch( R )
      {
         case 5:
            if( m >= 0 )
               m_byte = MEMORY[m].Byte_5( );
            else
               m_byte = cs_MEMORY[-m].Byte_5( );

            break;

         case 4:
            if( m >= 0 )
               m_byte = MEMORY[m].Byte_4( );
            else
               m_byte = cs_MEMORY[-m].Byte_4( );

            break;

         case 3:
            if( m >= 0 )
               m_byte = MEMORY[m].Byte_3( );
            else
               m_byte = cs_MEMORY[-m].Byte_3( );

            break;

         case 2:
            if( m >= 0 )
               m_byte = MEMORY[m].Byte_2( );
            else
               m_byte = cs_MEMORY[-m].Byte_2( );

            break;

         case 1:
            if( m >= 0 )
               m_byte = MEMORY[m].Byte_1( );
            else
               m_byte = cs_MEMORY[-m].Byte_1( );

            break;

         case 0:
            if( m >= 0 )
               m_byte = MEMORY[m].Byte_0( );
            else
               m_byte = cs_MEMORY[-m].Byte_0( );

            break;

      }

      if( R )
      {
         reg_field |= (reg_byte << (6 * (5 - R)));
         m_field |= (m_byte << (6 * (5 - R)));
      }
      else
      {
         if( reg_byte )
            reg_field = -reg_field;

         if( m_byte )
            m_field = -m_field;
      }

      R--;
   }

   if( reg_field < m_field )
   {
      COMPI.Byte_0( 1 );
      COMPI.Byte_5( 1 );
   }
   else if( reg_field == m_field )
   {
      COMPI.Byte_0( 0 );
      COMPI.Byte_5( 0 );
   }
   else
   {
      COMPI.Byte_0( 0 );
      COMPI.Byte_5( 1 );
   }

   u_counter += 2;
}
