///////////////////////////////////////////
//
// file:  JCMP.cpp
//
// Copyright 2004 John R. Ashmun
//                jrashmun@halcyon.com
//
//    This file is part of MIX. 
//
//    MIX is free software; you can redistribute it and/or modify 
//    it under the terms of the GNU General Public License as
//    published by the Free Software Foundation; either version 2
//    of the License, or (at your option) any later version. 
//
//    MIX is distributed in the hope that it will be useful, 
//    but WITHOUT ANY WARRANTY; without even the implied warranty of 
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
//    GNU General Public License for more details. 
//
//    You should have received a copy of the GNU General Public
//    License along with MIX; if not, write to the
//    Free Software Foundation, Inc.
//    59 Temple Place, Suite 330
//    Boston MA 02111-1307  USA
//
///////////////////////////////////////////


#include "MIX.h"


void JCMP( )
{
   int compi = COMPI.Byte_5( );
   if( COMPI.Byte_0( ) )
      compi = -compi;

   int f = INST.F( );

   switch( f )
   {
      case 0:
         JREG.Byte_4( (program_counter >> 6) & 0x3F );
         JREG.Byte_5( program_counter & 0x3F );

         program_counter = INST.M( );
         break;

      case 1:
         program_counter = INST.M( );
         break;

      case 2:
         if( OVTOG.Byte_5( ) )
         {
            JREG.Byte_4( (program_counter >> 6) & 0x3F );
            JREG.Byte_5( program_counter & 0x3F );

            program_counter = INST.M( );
         }

         OVTOG.Byte_5( 0 );
         break;

      case 3:
         if( !OVTOG.Byte_5( ) )
         {
            JREG.Byte_4( (program_counter >> 6) & 0x3F );
            JREG.Byte_5( program_counter & 0x3F );

            program_counter = INST.M( );
         }

         OVTOG.Byte_5( 0 );
         break;

      case 4:
         if( compi == -1 )
         {
            JREG.Byte_4( (program_counter >> 6) & 0x3F );
            JREG.Byte_5( program_counter & 0x3F );

            program_counter = INST.M( );
         }
         break;

      case 5:
         if( compi == 0 )
         {
            JREG.Byte_4( (program_counter >> 6) & 0x3F );
            JREG.Byte_5( program_counter & 0x3F );

            program_counter = INST.M( );
         }
         break;

      case 6:
         if( compi == 1 )
         {
            JREG.Byte_4( (program_counter >> 6) & 0x3F );
            JREG.Byte_5( program_counter & 0x3F );

            program_counter = INST.M( );
         }
         break;

      case 7:
         if( compi != -1 )
         {
            JREG.Byte_4( (program_counter >> 6) & 0x3F );
            JREG.Byte_5( program_counter & 0x3F );

            program_counter = INST.M( );
         }
         break;

      case 8:
         if( compi != 0 )
         {
            JREG.Byte_4( (program_counter >> 6) & 0x3F );
            JREG.Byte_5( program_counter & 0x3F );

            program_counter = INST.M( );
         }
         break;

      case 9:
         if( compi != 1 )
         {
            JREG.Byte_4( (program_counter >> 6) & 0x3F );
            JREG.Byte_5( program_counter & 0x3F );

            program_counter = INST.M( );
         }
         break;

      default:
         break;
   }

   u_counter++;
}
