///////////////////////////////////////////
//
// file:  init_opcodes.cpp
//
// Copyright 2004 John R. Ashmun
//                jrashmun@halcyon.com
//
//    This file is part of MIXAL. 
//
//    MIXAL is free software; you can redistribute it and/or modify 
//    it under the terms of the GNU General Public License as
//    published by the Free Software Foundation; either version 2
//    of the License, or (at your option) any later version. 
//
//    MIXAL is distributed in the hope that it will be useful, 
//    but WITHOUT ANY WARRANTY; without even the implied warranty of 
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
//    GNU General Public License for more details. 
//
//    You should have received a copy of the GNU General Public
//    License along with MIXAL; if not, write to the
//    Free Software Foundation, Inc.
//    59 Temple Place, Suite 330
//    Boston MA 02111-1307  USA
//
///////////////////////////////////////////


#include "MIX.h"


void init_opcodes( map< string, int >& opcodes )
{
   opcodes["NOP"] = 0;
   opcodes["ADD"] = 1;
   opcodes["SUB"] = 2;
   opcodes["MUL"] = 3;
   opcodes["DIV"] = 4;
   opcodes["NUM"] = 5;
   opcodes["CHAR"] = 5;
   opcodes["HLT"] = 5;
   opcodes["ENB"] = 5;
   opcodes["DIS"] = 5;
   opcodes["INT"] = 5;
   opcodes["SLA"] = 6;
   opcodes["SRA"] = 6;
   opcodes["SLAX"] = 6;
   opcodes["SRAX"] = 6;
   opcodes["SLC"] = 6;
   opcodes["SRC"] = 6;
   opcodes["MOVE"] = 7;
   opcodes["LDA"] = 8;
   opcodes["LD1"] = 9;
   opcodes["LD2"] = 10;
   opcodes["LD3"] = 11;
   opcodes["LD4"] = 12;
   opcodes["LD5"] = 13;
   opcodes["LD6"] = 14;
   opcodes["LDX"] = 15;
   opcodes["LDAN"] = 16;
   opcodes["LD1N"] = 17;
   opcodes["LD2N"] = 18;
   opcodes["LD3N"] = 19;
   opcodes["LD4N"] = 20;
   opcodes["LD5N"] = 21;
   opcodes["LD6N"] = 22;
   opcodes["LDXN"] = 23;
   opcodes["STA"] = 24;
   opcodes["ST1"] = 25;
   opcodes["ST2"] = 26;
   opcodes["ST3"] = 27;
   opcodes["ST4"] = 28;
   opcodes["ST5"] = 29;
   opcodes["ST6"] = 30;
   opcodes["STX"] = 31;
   opcodes["STJ"] = 32;
   opcodes["STZ"] = 33;
   opcodes["JBUS"] = 34;
   opcodes["IOC"] = 35;
   opcodes["IN"] = 36;
   opcodes["OUT"] = 37;
   opcodes["JRED"] = 38;
   opcodes["JMP"] = 39;
   opcodes["JSJ"] = 39;
   opcodes["JOV"] = 39;
   opcodes["JNOV"] = 39;
   opcodes["JL"] = 39;
   opcodes["JE"] = 39;
   opcodes["JG"] = 39;
   opcodes["JGE"] = 39;
   opcodes["JNE"] = 39;
   opcodes["JLE"] = 39;
   opcodes["JAN"] = 40;
   opcodes["JAZ"] = 40;
   opcodes["JAP"] = 40;
   opcodes["JANN"] = 40;
   opcodes["JANZ"] = 40;
   opcodes["JANP"] = 40;
   opcodes["J1N"] = 41;
   opcodes["J1Z"] = 41;
   opcodes["J1P"] = 41;
   opcodes["J1NN"] = 41;
   opcodes["J1NZ"] = 41;
   opcodes["J1NP"] = 41;
   opcodes["J2N"] = 42;
   opcodes["J2Z"] = 42;
   opcodes["J2P"] = 42;
   opcodes["J2NN"] = 42;
   opcodes["J2NZ"] = 42;
   opcodes["J2NP"] = 42;
   opcodes["J3N"] = 43;
   opcodes["J3Z"] = 43;
   opcodes["J3P"] = 43;
   opcodes["J3NN"] = 43;
   opcodes["J3NZ"] = 43;
   opcodes["J3NP"] = 43;
   opcodes["J4N"] = 44;
   opcodes["J4Z"] = 44;
   opcodes["J4P"] = 44;
   opcodes["J4NN"] = 44;
   opcodes["J4NZ"] = 44;
   opcodes["J4NP"] = 44;
   opcodes["J5N"] = 45;
   opcodes["J5Z"] = 45;
   opcodes["J5P"] = 45;
   opcodes["J5NN"] = 45;
   opcodes["J5NZ"] = 45;
   opcodes["J5NP"] = 45;
   opcodes["J6N"] = 46;
   opcodes["J6Z"] = 46;
   opcodes["J6P"] = 46;
   opcodes["J6NN"] = 46;
   opcodes["J6NZ"] = 46;
   opcodes["J6NP"] = 46;
   opcodes["JXN"] = 47;
   opcodes["JXZ"] = 47;
   opcodes["JXP"] = 47;
   opcodes["JXNN"] = 47;
   opcodes["JXNZ"] = 47;
   opcodes["JXNP"] = 47;
   opcodes["INCA"] = 48;
   opcodes["DECA"] = 48;
   opcodes["ENTA"] = 48;
   opcodes["ENNA"] = 48;
   opcodes["INC1"] = 49;
   opcodes["DEC1"] = 49;
   opcodes["ENT1"] = 49;
   opcodes["ENN1"] = 49;
   opcodes["INC2"] = 50;
   opcodes["DEC2"] = 50;
   opcodes["ENT2"] = 50;
   opcodes["ENN2"] = 50;
   opcodes["INC3"] = 51;
   opcodes["DEC3"] = 51;
   opcodes["ENT3"] = 51;
   opcodes["ENN3"] = 51;
   opcodes["INC4"] = 52;
   opcodes["DEC4"] = 52;
   opcodes["ENT4"] = 52;
   opcodes["ENN4"] = 52;
   opcodes["INC5"] = 53;
   opcodes["DEC5"] = 53;
   opcodes["ENT5"] = 53;
   opcodes["ENN5"] = 53;
   opcodes["INC6"] = 54;
   opcodes["DEC6"] = 54;
   opcodes["ENT6"] = 54;
   opcodes["ENN6"] = 54;
   opcodes["INCX"] = 55;
   opcodes["DECX"] = 55;
   opcodes["ENTX"] = 55;
   opcodes["ENNX"] = 55;
   opcodes["CMPA"] = 56;
   opcodes["CMP1"] = 57;
   opcodes["CMP2"] = 58;
   opcodes["CMP3"] = 59;
   opcodes["CMP4"] = 60;
   opcodes["CMP5"] = 61;
   opcodes["CMP6"] = 62;
   opcodes["CMPX"] = 63;
}
