///////////////////////////////////////////
//
// file:  MIX_Jump_register.cpp
//
// Copyright 2004 John R. Ashmun
//                jrashmun@halcyon.com
//
//    This file is part of MIX. 
//
//    MIX is free software; you can redistribute it and/or modify 
//    it under the terms of the GNU General Public License as
//    published by the Free Software Foundation; either version 2
//    of the License, or (at your option) any later version. 
//
//    MIX is distributed in the hope that it will be useful, 
//    but WITHOUT ANY WARRANTY; without even the implied warranty of 
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
//    GNU General Public License for more details. 
//
//    You should have received a copy of the GNU General Public
//    License along with MIX; if not, write to the
//    Free Software Foundation, Inc.
//    59 Temple Place, Suite 330
//    Boston MA 02111-1307  USA
//
///////////////////////////////////////////


#include "MIX_Jump_register.h"


MIX_Jump_register::MIX_Jump_register( )
{
   _value._int_value = 0;
}


MIX_Jump_register::~MIX_Jump_register( )
{
}


MIX_Jump_register::MIX_Jump_register( const MIX_Jump_register& JREG )
{
   _value._int_value = JREG._value._int_value;
}


MIX_Jump_register& MIX_Jump_register::operator=( const MIX_Jump_register& JREG )
{
   _value._int_value = JREG._value._int_value;

   return *this;
}


MIX_Jump_register::MIX_Jump_register( const int number )
{
   if( number < 0 )
   {
      _value._int_value = (-number & 0xFFF);
      Byte_0( 1 );
   }
   else
      _value._int_value = (number & 0xFFF);
}


void MIX_Jump_register::Byte_0( const int s )
{
}


int MIX_Jump_register::Byte_0( ) const
{
   return 0;
}
